<template>
  <a-form :form="form" @submit="handleSubmit" class="form">
    <transition name="showInfo">
      <a-alert
        v-if="notification"
        :type="notification.type"
        style="margin-bottom: 8px"
      >
        <template slot="message">
          {{ notification.message }}
        </template>
      </a-alert>
    </transition>

    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="メールアドレス"
    >
      <a-input
        v-decorator="[
          'email',
          {
            rules: [
              {
                required: true,
                message: 'メールアドレスを入力してください',
                validateFirst: true
              },
              {
                type: 'email',
                message: '正しいメールを入力してください',
                validateFirst: true
              }
            ],
            validateTrigger: ['change', 'blur'],
            initialValue: email
          }
        ]"
        @blur="handleValidateEmailExist"
        @change="handleChangeEmail"
        type="text"
        autocomplete="username"
        placeholder="メールアドレス"
      >
        <a-icon
          slot="prefix"
          :style="{ color: 'rgba(0,0,0,.25)' }"
          type="mail"
        />
      </a-input>
      <span slot="help" v-if="isExistedEmail" class="text-danger">
        メールアドレスはすでに登録されています。
      </span>
    </a-form-item>
    <a-form-item
      v-if="!isEdit"
      v-bind="formItemLayout"
      :required="true"
      label="パスワード"
    >
      <a-input
        v-decorator="[
          'password',
          {
            rules: [{ validator: handlePasswordCheck }],
            validateTrigger: ['change', 'blur']
          }
        ]"
        type="password"
        autocomplete="new-password"
        placeholder="パスワード"
      >
        <a-icon slot="prefix" type="lock" style="color:rgba(0,0,0,.25)" />
      </a-input>
    </a-form-item>

    <a-form-item
      v-if="!isEdit"
      v-bind="formItemLayout"
      :required="true"
      label="パスワード確認"
    >
      <a-input
        v-decorator="[
          'password2',
          {
            rules: [{ validator: handlePasswordCheck }],
            validateTrigger: ['change', 'blur']
          }
        ]"
        type="password"
        autocomplete="false"
        placeholder="パスワード確認"
      >
        <a-icon
          slot="prefix"
          :style="{ color: 'rgba(0,0,0,.25)' }"
          type="lock"
        />
      </a-input>
    </a-form-item>

    <div v-if="showSubmit" style="text-align: right;">
      <a-button :loading="saving" type="primary" html-type="submit">
        変更情報を存在する
      </a-button>
    </div>
  </a-form>
</template>

<script>
import { mapGetters } from 'vuex'
import { timer } from 'rxjs'
import { mixinDevice } from '@/utils/mixin'

export default {
  name: 'InfoForm',
  mixins: [mixinDevice],
  props: {
    isEdit: {
      type: Boolean,
      default: false
    },
    showSubmit: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      saving: false,
      notification: null,
      form: this.$form.createForm(this),
      isExistedEmail: false,
      formItemLayout: {
        colon: false,
        labelCol: {
          xs: { span: 24 },
          sm: { span: 8 }
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 }
        }
      }
    }
  },
  computed: {
    ...mapGetters('auth', ['email'])
  },

  methods: {
    // TODO: Validate email is existed
    handleChangeEmail () {
      this.isExistedEmail = false
    },
    async handleValidateEmailExist () {
      if (this.form.getFieldError('email')) { return }
      const email = this.form.getFieldValue('email')
      try {
        this.isExistedEmail = await this.$jobApi.isExistedEmail(email)
      } catch (error) {
        console.error(error)
      }
    },
    handlePasswordCheck (rule, value, callback) {
      const password = this.form.getFieldValue('password')
      if (value === undefined) {
        callback(new Error('パスワードを入力してください'))
      }
      if (value && password && value.trim().length < 8) {
        callback(new Error('パスワードは半角英数字８文字以上を設定してください。'))
      }

      if (value && password && value.trim() !== password.trim()) {
        callback(new Error('2つのパスワードに一貫性がありません'))
      }
      callback()
    },
    handleSubmit (e) {
      e.preventDefault()
      this.form.validateFields((err, values) => {
        if (!err) {
          const { email } = values
          console.log(email)
        }
      })
    },
    setInfo (notification) {
      this.notification = notification

      // auto hide message
      this.$subscribeTo(timer(2000), () => {
        this.notification = null
      })
    }
  }
}
</script>

<style scoped>
.showInfo-enter-active {
  transition: all 0.25s ease;
}
.showInfo-leave-active {
  transition: all 0.5s ease;
}
.showInfo-enter,
.showInfo-leave-to {
  opacity: 0;
}
</style>
